option explicit

'Objektvariablen
'---------------
dim objCom
dim objCon
dim objDatei
dim objErg
dim objField
dim objFs
dim objGrp
dim objLink
dim objMember
dim objOrdner
dim objRootDSE
dim objRS
dim objSLogDatei
dim objSubfolder
dim objUser
dim objWSHshell


'Stringvariablen
'---------------
dim strAbbruch
dim strArray
dim strAttr
dim strAttrValue
dim strAV
dim strCheck
dim strCheckRpl
dim strCMD
dim strCommand
dim strDate
dim strDescription
dim strDIFF_minus
dim strDIFF_plus
dim strDistinguishedName
dim strDN
dim strDNSDomain
dim strErg
dim strErg_neu
dim strErgDatei
dim strFeld
dim strJahr
dim strMonat
dim strName
dim strName_alt
dim strOptions
dim strPfad
dim strQuery
dim strRUN
dim strsAMAccountName
dim strShowAttrib
dim strTab
dim strTag
dim strValue
dim strZeile

dim strCMDline
dim strExpression
dim strRegAusdr
dim Uebereinstimmungen
dim Uebereinstimmung
dim strRueckgabe
dim strOptions_G
dim strOptions_Attrib
dim regAusdr

'Integervariablen
'----------------
dim intArr
dim intHighRange
dim intLowRange
dim intRangeStep
dim intSize


dim strHelp

On Error Resume Next

Set objFs = CreateObject("Scripting.FileSystemObject")
Set objWSHshell = CreateObject("WScript.Shell")

strHelp = 		"MemberOf.vbs listet alle Gruppenmitglieder (auch Gruppen mit mehr als 1000 Mitglieder) einer Domnengruppe auf." & vbCrLf & _
  				"Es werden alle verschachtelte Gruppen aufgelst. Standardmig wird nur der samAccountname in einer Textdatei ausgegeben." & vbCrLf & _ 
  				"Nachfolgende Befehlszeilenargumente sind mglich: " & vbCrLf & vbCrLf & _
  				"/g:Gruppenname" & Chr(009) & Chr(009) & Chr(009) & "z.B.: /g:domnen-admins" & vbCrLf & _
  				"/attrib:Attribut1|Attribut2" & Chr(009) & "z.B.: /attrib:mail|description" & vbCrLf & _
  				"/showAttrib zeigt eine Auswahl mit mglichen Attributen (nur singlevalue)" & vbCrLf & vbCrLf & _
  				"Die Befehhlszeilenargumente mssen von Hochkommas umschlossen werden, z.B.:" & vbCrLf & vbCrLf & _
  				"cscript memberof.vbs " & Chr(034) & "/g:domnen-admins /attrib:mail|description|displayname" & Chr(034)

'Befehlszeilenargumente prfen
'-----------------------------
If (Wscript.Arguments.Count <> 1) Then
    'Wscript.Echo "Befehlszeilenargumente fehlen " & vbCrLf & "Bsp.:" & vbCrLf & "cscript " & wscript.scriptname & Chr(032) & Chr(034) & "/g:domnen-admins" & Chr(034)
    wscript.echo strHelp
    Wscript.Quit()
End If


'**********************************************************************************************************
strOptions = LCase(Wscript.Arguments(0))

'bergabe der Parameter ber Kommandozeileneingabe
'----------------------------------------------------
If InStr(strOptions,"/?") > 0 then
  	wscript.echo strHelp
  	Ende()
End If
If InStr(strOptions,"/showattrib") > 0 then  		
	strShowAttrib = 	"department" & Chr(009) & Chr(009) & Chr(009) & "Abteilung" & vbCrLf & _
						"description" & Chr(009) & Chr(009) & Chr(009) & "Beschreibung" & vbCrLf & _
						"displayName" & Chr(009) & Chr(009) & Chr(009) & "Anzeigename" & vbCrLf & _
						"distinguishedName" & Chr(009) & Chr(009) & "DistinguishedName" & vbCrLf & _
						"extensionAttribute1" & Chr(009) & Chr(009) & "benutzerdefiniertes Attribut1" & vbCrLf & _
						"extensionAttribute2" & Chr(009) & Chr(009) & "benutzerdefiniertes Attribut2" & vbCrLf & _
						"extensionAttribute3" & Chr(009) & Chr(009) & "benutzerdefiniertes Attribut3" & vbCrLf & _
						"extensionAttribute4" & Chr(009) & Chr(009) & "benutzerdefiniertes Attribut4" & vbCrLf & _
						"extensionAttribute5" & Chr(009) & Chr(009) & "benutzerdefiniertes Attribut5" & vbCrLf & _
						"extensionAttribute6" & Chr(009) & Chr(009) & "benutzerdefiniertes Attribut6" & vbCrLf & _
						"extensionAttribute7" & Chr(009) & Chr(009) & "benutzerdefiniertes Attribut7" & vbCrLf & _
						"extensionAttribute8" & Chr(009) & Chr(009) & "benutzerdefiniertes Attribut8" & vbCrLf & _
						"extensionAttribute9" & Chr(009) & Chr(009) & "benutzerdefiniertes Attribut9" & vbCrLf & _
						"extensionAttribute10" & Chr(009) & Chr(009) & "benutzerdefiniertes Attribut10" & vbCrLf & _
						"facsimileTelephoneNumber" & Chr(009) & "facsimileTelephoneNumber" & vbCrLf & _
						"givenName" & Chr(009) & Chr(009) & Chr(009) & "Vorname" & vbCrLf & _
						"homeMDB" & Chr(009) & Chr(009) & Chr(009) & Chr(009) & "Postfachservername" & vbCrLf & _
						"homeMTA" & Chr(009) & Chr(009) & Chr(009) & Chr(009) & "MTA fr Postfach" & vbCrLf & _
						"legacyExchangeDN" & Chr(009) & Chr(009) & "legacyExchangeDN" & vbCrLf & _
						"mail" & Chr(009) & Chr(009) & Chr(009) & Chr(009) & "Mailadresse" & vbCrLf & _
						"mailNickname" & Chr(009) & Chr(009) & Chr(009) & "mailNickname" & vbCrLf & _
						"mDBOverQuotaLimit" & Chr(009) & Chr(009) & "Senden verbieten ab (KB)" & vbCrLf & _
						"mDBStorageQuota" & Chr(009) & Chr(009) & Chr(009) & "Warnmeldung senden ab (KB)" & vbCrLf & _
						"mDBUseDefaults" & Chr(009) & Chr(009) & Chr(009) & "Standardwerte fr Postfachspeicher verwenden" & vbCrLf & _
						"msExchHideFromAddressLists" & Chr(009) & "nicht in Exchange Adresslisten anzeigen" & vbCrLf & _
						"msExchHomeServerName" & Chr(009) & Chr(009) & "Servername fr Postfach" & vbCrLf & _
						"msNPAllowDialin" & Chr(009) & Chr(009) & Chr(009) & "RAS-Berechtigung" & vbCrLf & _
						"msRADIUSServiceType" & Chr(009) & Chr(009) & "Rckrufoption" & vbCrLf & _
						"name" & Chr(009) & Chr(009) & Chr(009) & Chr(009) & "Objektname" & vbCrLf & _
						"objectCategory" & Chr(009) & Chr(009) & Chr(009) & "Objektkategorie" & vbCrLf & _
						"showInAddressBook" & Chr(009) & Chr(009) & "showInAddressBook" & vbCrLf & _
						"sn" & Chr(009) & Chr(009) & Chr(009) & Chr(009) & "Nachname" & vbCrLf & _
						"telephoneNumber" & Chr(009) & Chr(009) & Chr(009) & "Telefonnummer" & vbCrLf & _
						"whenChanged" & Chr(009) & Chr(009) & Chr(009) & "wann gendert" & vbCrLf & _
						"whenCreated" & Chr(009) & Chr(009) & Chr(009) & "wann erstellt"
	wscript.echo strShowAttrib
	Ende()
End If
If Not strOptions = "" and not InStr(strOptions,"/?") and not InStr(strOptions, "/showattrib") > 0 Then	
	strExpression = "(/g:)[^/\\\[\]:;|=+*?<>@]+"	
	RegEx strExpression, strOptions
	strOptions_G = Replace(RTrim(strRueckgabe), "/g:", "")
	
	strExpression = "(/attrib:)[^/\\\[\]:;=+*?<>@]+"	
	RegEx strExpression, strOptions
	strOptions_Attrib = Replace(RTrim(strRueckgabe), "/attrib:", "")
	If strOptions_Attrib <> "" and not InStr(strOptions_Attrib,"samaccountname") > 0 then
		strOptions_Attrib = "samaccountname|" & strOptions_Attrib
	End If
  Else			

End If
'--------------------------------------------------------------------------   
Public Function RegEx(strExpression, strOptions)   
   strRueckgabe = ""
   Set regAusdr = New RegExp   ' Erstellt einen regulren Ausdruck.
   regAusdr.Pattern = strExpression
   regAusdr.IgnoreCase = True   ' Ignoriert die Schreibweise.
   regAusdr.Global = True   ' Legt globales Anwenden fest.
   Set Uebereinstimmungen = regAusdr.Execute(strOptions)   ' Fhrt die Suche aus.
   For Each Uebereinstimmung In Uebereinstimmungen   ' Durchluft die Auflistung der Uebereinstimmungen.
      strRueckgabe = Uebereinstimmung.Value
   Next
End Function
'*************************************************************************************************************
strFeld = Split(strOptions_Attrib,"|",-1,1)

'Arbeitsverzeichnis
'------------------
strAV = objFs.GetParentFolderName(objFs.GetFile(wscript.scriptname)) & "\"

'amerikanisches Datumsformat
'---------------------------
If Len(Day(Date)) = 1 then
	strTag = "0" & Day(Date)
  Else
  	strTag = Day(Date)
End If
If Len(Month(Date)) = 1 then
	strMonat = "0" & Month(Date)
  Else
  	strMonat = Month(Date)
End If
strJahr = Year(Date)
strDate = strJahr & strMonat & strTag

'SLog-Ordner anlegen und SLog-Datei ffnen
'-----------------------------------------
If not objFs.FolderExists(strAV & "\SLog_" & wscript.scriptname) then
	objFs.CreateFolder(strAV & "\SLog_" & wscript.scriptname)
End If

strErgDatei = strAV & "MemberOf_" & strOptions_G & ".txt"

Set objSLogDatei = objFs.OpenTextFile(strAV & "\SLog_" & wscript.scriptname & "\SLog_" & wscript.scriptname & "_" & strDate & ".txt",8,True)
Set objErg = objFs.CreateTextFile(strErgDatei,True)
objErg.WriteLine "Mitglieder in der Gruppe: " & strOptions_G

'**********SLogeintrge schreiben************************************
objSLogDatei.WriteLine Time & Chr(009) & "Arbeitsverzeichnis: " & strAV
'*********************************************************************

If not objFs.FolderExists(strAV & "log") then
	objFs.CreateFolder(strAV & "log")
	'***********SLogeintrge schreiben***********************************************************
	objSLogDatei.WriteLine Time & Chr(009) & "Ordner nicht vorhanden > angelegt: " & strAV & "log"
	'********************************************************************************************
End If
'------------------------------------------------------------------------------------------------
'LDAP-Abfrage
'------------
'Domnennamen ermitteln
Set objRootDSE = GetObject("LDAP://RootDSE")
strDNSDomain = objRootDSE.Get("DefaultNamingContext")

strAttr = "name,distinguishedname"	'auszulesende Attribute im AD
Set objCon = CreateObject("ADODB.Connection")
Set objCom = CreateObject("ADODB.Command") 

	
objCon.Provider = "ADsDSOObject"  
objCon.Open 	
objCom.ActiveConnection = objCon 	
objCom.Properties("Page Size") = 1000
objCom.Properties("Size Limit") = 3000 
	
intLowRange 	= 0
intRangeStep 	= 999
IntHighRange 	= intLowRange + intRangeStep
strTab 			= Chr(009)

strQuery = "<LDAP://" & strDNSDomain & ">;(&(ObjectCategory=group)(ObjectClass=group)(sAMAccountName=" & strOptions_G & "));member;Range=" & intLowRange & "-" & intHighRange & ";subtree"

objSLogDatei.WriteLine Time & Chr(009) & Chr(009) & "ABFRAGE Gruppe..." & strOptions_G & "...AUFRUF SUB EnumMembers"
objSLogDatei.WriteBlankLines(1)
objSLogDatei.WriteLine Time & Chr(009) & "ABFRAGE: " & strQuery

EnumMembers strQuery, false, strOptions_G, strTab

objErg.WriteBlankLines(2)
If strOptions_Attrib <> "" then
	objErg.WriteLine strOptions_Attrib
  else
  	objErg.WriteLine "samAccountName"
End If  
objErg.write strErg
objErg.Close

'"|" als letztes Zeichen in allen Zeilen lschen
'-----------------------------------------------
strErg = ""
Set objErg = objFs.OpenTextFile(strErgDatei,1)
Do until objErg.AtEndOfStream
	strZeile = objErg.ReadLine
	If Right(strZeile,1) = "|" then
		strErg = strErg & Left(strZeile,Len(strZeile)-1) & vbCrLf
	  Else
	  	strErg = strErg & strZeile & vbCrLf
	End If
Loop
objErg.Close
strErg = Replace(strErg,"|",Chr(9))

'Ergebnisdatei neu erstellen
'---------------------------
Set objErg = objFs.CreateTextFile(strErgDatei,True)
objErg.write strErg
objErg.Close

Ende()
'----------------------------------------------------------------------------------------------------------------------------------
Sub EnumMembers(strCommand, strAbbruch, strName, strTab)   	
   	wscript.echo "LDAP-Abfrage....: " & strQuery
   	On Error Resume Next
   	dim objRS2
   
   	objCom.CommandText = strCommand
	Set objRS2 = objCom.Execute()
	intSize = 0
	
	If not InStr(LCase(strCheck),LCase(strName) & "|") > 0 then		
		strCheck = strCheck & LCase(strName) & "|"
		arrName(intArr) = strName
		intArr = intArr + 1
	End If
	
	Do Until objRS2.EOF        
        For Each objField In objRS2.Fields        	
        	If (VarType(objField) = (vbArray + vbVariant)) Then
            	For Each strDN In objField.Value                   		
    				intSize = intSize + 1
    				
              		Set objMember = GetObject("LDAP://" & strDN)
              		                   	
                   	If (UCase(objMember.Class) = "USER") Then						
						objSLogDatei.WriteLine Time & strTab & LCase(objMember.samaccountname)
						
						If not InStr(strErg, LCase(objMember.samaccountname) & "|") and strOptions_Attrib = "" then							
							strErg = strErg & LCase(objMember.samaccountname) & vbCrLf							
						End If
						
						If not InStr(strErg,LCase(objMember.samaccountname) & "|") and strOptions_Attrib <> "" then							
							For each strValue in strFeld								
								strAttrValue = ""
								strAttrValue = objMember.get(strValue)								
								If err.number = 0 then									
									strErg = strErg & strAttrValue & "|"
								  Else								  	
								  	strErg = strErg & "FEHLER: " & Replace(err.description,vbCrLf,"") & "|"
								  	err.Clear								  	
								End If
							Next
							If err.number = 0 then
								strErg = strErg & vbCrLf
							End If
						End If
						
                   	End If
                    	
                   	If (UCase(objMember.Class) = "GROUP") Then
   						
   						objSLogDatei.WriteLine Time & strTab & "GRUPPENMITGLIED gefunden in Gruppe " & Chr(034) & strName & Chr(034) & ":" & Chr(009) & LCase(objMember.SamAccountName)
                   		objSLogDatei.WriteLine Time & strTab & "strCheck = " & strCheck
                   		
                   		If not InStr(LCase(strCheck),LCase(objMember.SamAccountName & "|")) > 0 then                   			
                   			objSLogDatei.WriteLine Time & strTab & "folgendes Gruppenmitglied nicht in strCheck vorhanden..." & LCase(objMember.SamAccountName)
	                   		strCheck = strCheck & LCase(objMember.SamAccountName) & "|"                  		
	                   		strName = ""
	                   		strName = LCase(objMember.SamAccountName)
	                   		intLowRange = 0
							IntHighRange = intLowRange + intRangeStep
	                   		strQuery = "<LDAP://" & strDNSDomain & ">;(&(ObjectCategory=group)(ObjectClass=group)(sAMAccountName=" & strName & "));member;Range=" & intLowRange & "-" & intHighRange & ";subtree"
                   			objSLogDatei.WriteBlankLines(1)
                   			objSLogDatei.WriteLine Time & strTab & "ABFRAGE INNERHALB...: >> " & LCase(objMember.SamAccountName)
							objSLogDatei.WriteBlankLines(1)
							objSLogDatei.WriteLine Time & strTab & "ABFRAGE: " & strQuery
							strTab = strTab & Chr(009)
                   			EnumMembers strQuery, false, strName, strTab
                   		  Else
                   		  	objSLogDatei.WriteLine Time & strTab & "GRUPPENMITGLIED in strCheck gefunden...Gruppe wird nicht abgefragt!"
                   		End If                    		
                   	End If	
        		Next
        	End If
        Next
		objRS2.MoveNext
	Loop
	objRS2.Close
	
	If strAbbruch = true then		
		objSLogDatei.WriteLine Time & strTab & "...strAbbruch = true...beende Sub EnumMembers!"
		strTab = Replace(strTab,Chr(009),"",1,1,vbTextCompare)
		exit Sub
	End If
	
	If intSize > 0 then		
	    intLowRange = intHighRange + 1
	    intHighRange = intLowRange + intRangeStep	    
	End If
    
	If intSize > 0 then
		strQuery = "<LDAP://" & strDNSDomain & ">;(&(ObjectCategory=group)(ObjectClass=group)(sAMAccountName=" & strName & "));member;Range=" & intLowRange & "-" & intHighRange & ";subtree"		
	  	objSLogDatei.WriteLine Time & strTab & "ABFRAGE: " & strQuery
	  Else
	  	strQuery = "<LDAP://" & strDNSDomain & ">;(&(ObjectCategory=group)(ObjectClass=group)(sAMAccountName=" & strName & "));member;Range=" & intLowRange & "-*;subtree"
	  	objSLogDatei.WriteLine Time & strTab & "ABFRAGE: " & strQuery
	  	objSLogDatei.WriteLine Time & strTab & "letzter Schleifendurchgang >> strAbbruch = true"
	  	strAbbruch = true
	End If
	
	EnumMembers strQuery, strAbbruch, strName, strTab
End Sub
'-----------------------------------------------------------------------------------------------------------------------------
Sub Ende()
	Set objFs 		= Nothing
	Set objWSHshell = Nothing
	Set objCon 		= Nothing
	Set objCom 		= Nothing
	wscript.quit() 
End Sub
